diff --git a/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectile.java b/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
similarity index 94%
rename from src/main/java/net/minecraft/core/entity/projectile/ArrowProjectile.java
rename to src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
index 4cd0e03ed..6eb8cd34b 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/ArrowProjectile.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.entity.projectile;
 
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.core.achievement.Achievement;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
@@ -21,7 +20,7 @@ import net.minecraft.core.world.World;
 //            MovingObjectPosition, NBTTagCompound, ItemStack, Item, 
 //            InventoryPlayer
 
-public class ArrowProjectile extends Projectile
+public class ProjectileArrow extends Projectile
 {
     public static final int TYPE_NORMAL = 0;
     public static final int TYPE_PURPLE = 1;
@@ -45,23 +44,23 @@ public class ArrowProjectile extends Projectile
     protected boolean inGround = false;
     protected boolean doesArrowBelongToPlayer = false;
 
-	public ArrowProjectile(World world) {
+	public ProjectileArrow(World world) {
 		this(world, TYPE_NORMAL);
 	}
 	
-    public ArrowProjectile(World world, int arrowType)
+    public ProjectileArrow(World world, int arrowType)
     {
         super(world);
         this.arrowType = arrowType;
     }
 
-    public ArrowProjectile(World world, double d, double d1, double d2, int arrowType)
+    public ProjectileArrow(World world, double d, double d1, double d2, int arrowType)
     {
         super(world, d, d1, d2);
         this.arrowType = arrowType;
     }
 
-    public ArrowProjectile(World world, Mob entityliving, boolean doesArrowBelongToPlayer, int arrowType)
+    public ProjectileArrow(World world, Mob entityliving, boolean doesArrowBelongToPlayer, int arrowType)
     {
         super(world, entityliving);
         setDoesArrowBelongToPlayer(doesArrowBelongToPlayer);
@@ -153,7 +152,7 @@ public class ArrowProjectile extends Projectile
             }
             return;
         }
-        else if(this instanceof GoldenArrowProjectile)
+        else if(this instanceof ProjectileArrowGolden)
         {
             world.spawnParticle("arrowtrail", x, y, z, xd * 0.05D, yd * 0.05D - 0.1D, zd * 0.05D, 0);
             world.spawnParticle("arrowtrail", x + xd * 0.5D, y + yd * 0.5D, z + zd * 0.5D, xd * 0.05D, yd * 0.05D - 0.1D, zd * 0.05D, 0);
@@ -175,7 +174,7 @@ public class ArrowProjectile extends Projectile
                 if(!world.isClientSide) {
                 	world.playSoundAtEntity(null, this, "random.drr", 1.0F, 1.2F / (random.nextFloat() * 0.2F + 0.9F));
                 }
-                if(!(this instanceof GoldenArrowProjectile))
+                if(!(this instanceof ProjectileArrowGolden))
                 {
                     remove();
                 } else {
@@ -183,7 +182,7 @@ public class ArrowProjectile extends Projectile
                         ((Player) owner).addStat(Achievements.TRIPLE_HIT, 1);
                     }
                 }
-            } else if(!(this instanceof GoldenArrowProjectile))
+            } else if(!(this instanceof ProjectileArrowGolden))
             {
                 xd *= -0.1D;
                 yd *= -0.1D;
diff --git a/src/main/java/net/minecraft/core/entity/projectile/GoldenArrowProjectile.java b/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrowGolden.java
similarity index 85%
rename from src/main/java/net/minecraft/core/entity/projectile/GoldenArrowProjectile.java
rename to src/main/java/net/minecraft/core/entity/projectile/ProjectileArrowGolden.java
index a16b3ad88..5b1eeae44 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/GoldenArrowProjectile.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrowGolden.java
@@ -12,24 +12,24 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
-public class GoldenArrowProjectile extends ArrowProjectile
+public class ProjectileArrowGolden extends ProjectileArrow
 {
 
-    public GoldenArrowProjectile(World world)
+    public ProjectileArrowGolden(World world)
     {
         super(world, TYPE_GOLDEN);
         this.noPhysics = true;
         stack = new ItemStack(Items.AMMO_ARROW_GOLD);
     }
 
-    public GoldenArrowProjectile(World world, double x, double y, double z)
+    public ProjectileArrowGolden(World world, double x, double y, double z)
     {
         super(world, x, y, z, TYPE_GOLDEN);
         this.noPhysics = true;
         stack = new ItemStack(Items.AMMO_ARROW_GOLD);
     }
 
-    public GoldenArrowProjectile(World world, Mob owner, boolean doesArrowBelongToPlayer)
+    public ProjectileArrowGolden(World world, Mob owner, boolean doesArrowBelongToPlayer)
     {
         super(world, owner, doesArrowBelongToPlayer, TYPE_GOLDEN);
         this.noPhysics = true;
diff --git a/src/main/java/net/minecraft/core/entity/projectile/PurpleArrowProjectile.java b/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrowPurple.java
similarity index 83%
rename from src/main/java/net/minecraft/core/entity/projectile/PurpleArrowProjectile.java
rename to src/main/java/net/minecraft/core/entity/projectile/ProjectileArrowPurple.java
index ce9c9780e..a61e17827 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/PurpleArrowProjectile.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrowPurple.java
@@ -10,20 +10,20 @@ import net.minecraft.core.world.World;
 //            MovingObjectPosition, NBTTagCompound, ItemStack, Item, 
 //            InventoryPlayer
 
-public class PurpleArrowProjectile extends ArrowProjectile
+public class ProjectileArrowPurple extends ProjectileArrow
 {
 
-    public PurpleArrowProjectile(World world)
+    public ProjectileArrowPurple(World world)
     {
         super(world, TYPE_PURPLE);
     }
 
-    public PurpleArrowProjectile(World world, double x, double y, double z)
+    public ProjectileArrowPurple(World world, double x, double y, double z)
     {
         super(world, x, y, z, TYPE_PURPLE);
     }
 
-    public PurpleArrowProjectile(World world, Mob owner, boolean doesArrowBelongToPlayer)
+    public ProjectileArrowPurple(World world, Mob owner, boolean doesArrowBelongToPlayer)
     {
         super(world, owner, doesArrowBelongToPlayer, TYPE_PURPLE);
     }
diff --git a/src/main/java/net/minecraft/core/entity/projectile/CannonballProjectile.java b/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonball.java
similarity index 79%
rename from src/main/java/net/minecraft/core/entity/projectile/CannonballProjectile.java
rename to src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonball.java
index c0438a8a5..c632efc92 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/CannonballProjectile.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonball.java
@@ -4,20 +4,20 @@ import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.world.World;
 
-public class CannonballProjectile extends Projectile
+public class ProjectileCannonball extends Projectile
 {
 
-    public CannonballProjectile(World world)
+    public ProjectileCannonball(World world)
     {
         super(world);
     }
 
-    public CannonballProjectile(World world, Mob owner)
+    public ProjectileCannonball(World world, Mob owner)
     {
         super(world, owner);
     }
 
-    public CannonballProjectile(World world, double x, double y, double z)
+    public ProjectileCannonball(World world, double x, double y, double z)
     {
         super(world, x, y, z);
     }
diff --git a/src/main/java/net/minecraft/core/entity/projectile/CannonballBouncyProjectile.java b/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
similarity index 96%
rename from src/main/java/net/minecraft/core/entity/projectile/CannonballBouncyProjectile.java
rename to src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
index eae86b8ac..f4b2abd9a 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/CannonballBouncyProjectile.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
@@ -11,11 +11,11 @@ import net.minecraft.core.world.World;
 
 import java.util.List;
 
-public class CannonballBouncyProjectile extends CannonballProjectile
+public class ProjectileCannonballBouncy extends ProjectileCannonball
 {
     private int fuse = 50;
 
-    public CannonballBouncyProjectile(World world, Mob owner)
+    public ProjectileCannonballBouncy(World world, Mob owner)
     {
         super(world, owner);
         x += xd;
@@ -25,7 +25,7 @@ public class CannonballBouncyProjectile extends CannonballProjectile
         this.defaultGravity = 0.06f;
     }
 
-    public CannonballBouncyProjectile(World world, double x, double y, double z)
+    public ProjectileCannonballBouncy(World world, double x, double y, double z)
     {
         super(world, x, y, z);
         this.defaultGravity = 0.06f;
diff --git a/src/main/java/net/minecraft/core/entity/projectile/EggProjectile.java b/src/main/java/net/minecraft/core/entity/projectile/ProjectileEgg.java
similarity index 75%
rename from src/main/java/net/minecraft/core/entity/projectile/EggProjectile.java
rename to src/main/java/net/minecraft/core/entity/projectile/ProjectileEgg.java
index 4aba7d342..9a71174f4 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/EggProjectile.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/ProjectileEgg.java
@@ -1,27 +1,27 @@
 package net.minecraft.core.entity.projectile;
 
 import net.minecraft.core.entity.Mob;
-import net.minecraft.core.entity.animal.ChickenMob;
+import net.minecraft.core.entity.animal.MobChicken;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.World;
 
-public class EggProjectile extends Projectile
+public class ProjectileEgg extends Projectile
 {
 
-    public EggProjectile(World world)
+    public ProjectileEgg(World world)
     {
         super(world);
         this.modelItem = Items.EGG_CHICKEN;
     }
 
-    public EggProjectile(World world, Mob owner)
+    public ProjectileEgg(World world, Mob owner)
     {
         super(world, owner);
         this.modelItem = Items.EGG_CHICKEN;
     }
 
-    public EggProjectile(World world, double x, double y, double z)
+    public ProjectileEgg(World world, double x, double y, double z)
     {
         super(world, x, y, z);
         this.modelItem = Items.EGG_CHICKEN;
@@ -38,7 +38,7 @@ public class EggProjectile extends Projectile
             }
             for(int k = 0; k < byte0; k++)
             {
-                ChickenMob entitychicken = new ChickenMob(world);
+                MobChicken entitychicken = new MobChicken(world);
                 entitychicken.moveTo(x, y, z, yRot, 0.0F);
                 world.entityJoinedWorld(entitychicken);
             }
diff --git a/src/main/java/net/minecraft/core/entity/projectile/FireballProjectile.java b/src/main/java/net/minecraft/core/entity/projectile/ProjectileFireball.java
similarity index 92%
rename from src/main/java/net/minecraft/core/entity/projectile/FireballProjectile.java
rename to src/main/java/net/minecraft/core/entity/projectile/ProjectileFireball.java
index 6a0baca1c..fa7230218 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/FireballProjectile.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/ProjectileFireball.java
@@ -2,7 +2,7 @@ package net.minecraft.core.entity.projectile;
 
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.entity.Mob;
-import net.minecraft.core.entity.monster.GhastMob;
+import net.minecraft.core.entity.monster.MobGhast;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.util.phys.Vec3;
@@ -15,17 +15,17 @@ import net.minecraft.core.util.helper.DamageType;
 //            Entity, AxisAlignedBB, MathHelper, Mob,
 //            World, Vec3D, MovingObjectPosition, NBTTagCompound
 
-public class FireballProjectile extends Projectile
+public class ProjectileFireball extends Projectile
 {
     public static final double FIREBALL_SPEED = 1d;
 
-    public FireballProjectile(World world)
+    public ProjectileFireball(World world)
     {
         super(world);
         setSize(1.0F, 1.0F);
     }
 
-    public FireballProjectile(World world, double x, double y, double z,
+    public ProjectileFireball(World world, double x, double y, double z,
                               double vX, double vY, double vZ)
     {
         super(world);
@@ -34,7 +34,7 @@ public class FireballProjectile extends Projectile
         setPos(x, y, z);
         setVelocity(vX, vY, vZ, FIREBALL_SPEED);
     }
-    public FireballProjectile(World world, Mob owner, double vX, double vY, double vZ)
+    public ProjectileFireball(World world, Mob owner, double vX, double vY, double vZ)
     {
         super(world);
         setSize(1.0F, 1.0F);
@@ -81,7 +81,7 @@ public class FireballProjectile extends Projectile
             {
                 if(result.entity != null)
                 {
-                    if (result.entity instanceof GhastMob){
+                    if (result.entity instanceof MobGhast){
                         result.entity.hurt(owner, 20, DamageType.COMBAT);
                     } else {
                         result.entity.hurt(owner, damage, DamageType.COMBAT);
diff --git a/src/main/java/net/minecraft/core/entity/projectile/PebbleProjectile.java b/src/main/java/net/minecraft/core/entity/projectile/ProjectilePebble.java
similarity index 83%
rename from src/main/java/net/minecraft/core/entity/projectile/PebbleProjectile.java
rename to src/main/java/net/minecraft/core/entity/projectile/ProjectilePebble.java
index 8ea779de1..d1c9b657e 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/PebbleProjectile.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/ProjectilePebble.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.entity.projectile;
 
+import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.util.phys.HitResult;
-import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
@@ -13,21 +13,21 @@ import net.minecraft.core.world.World;
 //            World, Vec3D, MovingObjectPosition, NBTTagCompound, 
 //            Player, ItemStack, Item, InventoryPlayer
 
-public class PebbleProjectile extends Projectile
+public class ProjectilePebble extends Projectile
 {
     private boolean firstBounce = true;
 
-    public PebbleProjectile(World world)
+    public ProjectilePebble(World world)
     {
         super(world);
     }
 
-    public PebbleProjectile(World world, Mob owner)
+    public ProjectilePebble(World world, Mob owner)
     {
         super(world, owner);
     }
 
-    public PebbleProjectile(World world, double x, double y, double z)
+    public ProjectilePebble(World world, double x, double y, double z)
     {
         super(world, x, y, z);
     }
@@ -45,7 +45,7 @@ public class PebbleProjectile extends Projectile
 
         if(!world.isClientSide)
         {
-            ItemEntity item = new ItemEntity(world, x, y, z, new ItemStack(Items.AMMO_PEBBLE, 1));
+            EntityItem item = new EntityItem(world, x, y, z, new ItemStack(Items.AMMO_PEBBLE, 1));
             world.entityJoinedWorld(item);
         }
 
diff --git a/src/main/java/net/minecraft/core/entity/projectile/SnowballProjectile.java b/src/main/java/net/minecraft/core/entity/projectile/ProjectileSnowball.java
similarity index 72%
rename from src/main/java/net/minecraft/core/entity/projectile/SnowballProjectile.java
rename to src/main/java/net/minecraft/core/entity/projectile/ProjectileSnowball.java
index 31a6a1ae3..4bca556fe 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/SnowballProjectile.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/ProjectileSnowball.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.entity.projectile;
 
 import net.minecraft.core.entity.Mob;
-import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.world.World;
 
@@ -10,22 +9,22 @@ import net.minecraft.core.world.World;
 //            World, Vec3D, MovingObjectPosition, NBTTagCompound, 
 //            Player, ItemStack, Item, InventoryPlayer
 
-public class SnowballProjectile extends Projectile
+public class ProjectileSnowball extends Projectile
 {
 
-    public SnowballProjectile(World world)
+    public ProjectileSnowball(World world)
     {
         super(world);
         this.modelItem = Items.AMMO_SNOWBALL;
     }
 
-    public SnowballProjectile(World world, Mob owner)
+    public ProjectileSnowball(World world, Mob owner)
     {
         super(world, owner);
         this.modelItem = Items.AMMO_SNOWBALL;
     }
 
-    public SnowballProjectile(World world, double x, double y, double z)
+    public ProjectileSnowball(World world, double x, double y, double z)
     {
         super(world, x, y, z);
         this.modelItem = Items.AMMO_SNOWBALL;
diff --git a/src/main/java/net/minecraft/core/entity/vehicle/BoatEntity.java b/src/main/java/net/minecraft/core/entity/vehicle/BoatEntity.java
index bcdba4599..b374d8362 100644
--- a/src/main/java/net/minecraft/core/entity/vehicle/BoatEntity.java
+++ b/src/main/java/net/minecraft/core/entity/vehicle/BoatEntity.java
@@ -1,11 +1,11 @@
 package net.minecraft.core.entity.vehicle;
 
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.client.entity.player.MultiplayerLocalPlayer;
-import net.minecraft.client.entity.player.LocalPlayer;
+import net.minecraft.client.entity.player.PlayerLocalMultiplayer;
+import net.minecraft.client.entity.player.PlayerLocal;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.entity.FlagBlockEntity;
+import net.minecraft.core.block.entity.TileEntityFlag;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
@@ -20,7 +20,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
-import net.minecraft.server.entity.player.ServerPlayer;
+import net.minecraft.server.entity.player.PlayerServer;
 
 import java.util.List;
 
@@ -53,7 +53,7 @@ public class BoatEntity extends Entity
     private double pendingXDChange;
     private double pendingZDChange;
     private ItemStack flag = null;
-    public FlagBlockEntity tileEntityFlag = null;
+    public TileEntityFlag tileEntityFlag = null;
 
 
     public BoatEntity(World world)
@@ -71,7 +71,7 @@ public class BoatEntity extends Entity
     private void createTileEntity()
     {
         if (this.flag == null) return;
-        this.tileEntityFlag = new FlagBlockEntity();
+        this.tileEntityFlag = new TileEntityFlag();
         CompoundTag flagData = this.flag.getData().getCompoundOrDefault("FlagData", null);
         if (flagData != null)
         {
@@ -212,7 +212,7 @@ public class BoatEntity extends Entity
         boatPitch = xRot;
         lerpTicks = i;
         // Don't interpolate velocity from server when controlling the boat
-        if (passenger instanceof LocalPlayer) return;
+        if (passenger instanceof PlayerLocal) return;
         lerpYRot = yRot;
         xd = velocityX;
         yd = velocityY;
@@ -223,7 +223,7 @@ public class BoatEntity extends Entity
 	public void lerpMotion(double xd, double yd, double zd)
     {
         // Don't interpolate velocity from server when controlling the boat
-        if (passenger instanceof LocalPlayer) return;
+        if (passenger instanceof PlayerLocal) return;
         velocityX = this.xd = xd;
         velocityY = this.yd = yd;
         velocityZ = this.zd = zd;
@@ -265,7 +265,7 @@ public class BoatEntity extends Entity
                 double lerpY = y + (this.lerpY - y) / (double) lerpTicks;
                 double lerpZ = z + (this.lerpZ - z) / (double) lerpTicks;
                 xRot += (boatPitch - xRot) / lerpTicks;
-                if (!(passenger instanceof MultiplayerLocalPlayer)){
+                if (!(passenger instanceof PlayerLocalMultiplayer)){
                     float lerpYRot;
                     lerpYRot = MathHelper.normalizeRotation(this.lerpYRot - yRot);
                     yRot += lerpYRot / lerpTicks;
@@ -333,7 +333,7 @@ public class BoatEntity extends Entity
 
         }
 
-        if (!(passenger instanceof ServerPlayer)){
+        if (!(passenger instanceof PlayerServer)){
             xd *= 0.99D;
             yd *= 0.95D;
             zd *= 0.99D;
@@ -388,9 +388,9 @@ public class BoatEntity extends Entity
         double xdOff;
         double zdOff;
         currentBoatSpeed = Math.hypot(xd, zd);
-        if(passenger != null && passenger instanceof LocalPlayer)
+        if(passenger != null && passenger instanceof PlayerLocal)
         {
-            LocalPlayer sp = (LocalPlayer) passenger;
+            PlayerLocal sp = (PlayerLocal) passenger;
             controlBoat(-sp.input.moveForward, -sp.input.moveStrafe);
         }
         yRot += pendingYRot;
@@ -411,8 +411,8 @@ public class BoatEntity extends Entity
         xd += xdOff;
         zd += zdOff;
 
-        if (passenger instanceof MultiplayerLocalPlayer){
-            ((MultiplayerLocalPlayer)passenger).sendQueue.addToSendQueue(new BoatControlPacket(this));
+        if (passenger instanceof PlayerLocalMultiplayer){
+            ((PlayerLocalMultiplayer)passenger).sendQueue.addToSendQueue(new BoatControlPacket(this));
         }
 
         // Cap max speed properly
diff --git a/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java b/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
index ddb05f295..61f9ef542 100644
--- a/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
+++ b/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
@@ -3,15 +3,14 @@ package net.minecraft.core.entity.vehicle;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.RailBlock;
+import net.minecraft.core.block.BlockRail;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.block.entity.ChestBlockEntity;
+import net.minecraft.core.block.entity.TileEntityChest;
 import net.minecraft.core.block.logic.RailDirection;
 import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.crafting.LookupFuelFurnace;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
@@ -232,13 +231,13 @@ public class MinecartEntity extends Entity implements Container {
                 double x1 = (double) (random.nextFloat() * range) + (double) (1.0F - range) * 0.5D;
                 double y1 = (double) (random.nextFloat() * range) + (double) (1.0F - range) * 0.5D;
                 double z1 = (double) (random.nextFloat() * range) + (double) (1.0F - range) * 0.5D;
-                ItemEntity itemEntity = new ItemEntity(world, x + x1, y + y1, z + z1, itemStack);
-                itemEntity.pickupDelay = 10;
-                world.entityJoinedWorld(itemEntity);
-                itemEntity.xd *= 0.5;
-                itemEntity.yd *= 0.5;
-                itemEntity.zd *= 0.5;
-                itemEntity.pickupDelay = 0;
+                EntityItem entityItem = new EntityItem(world, x + x1, y + y1, z + z1, itemStack);
+                entityItem.pickupDelay = 10;
+                world.entityJoinedWorld(entityItem);
+                entityItem.xd *= 0.5;
+                entityItem.yd *= 0.5;
+                entityItem.zd *= 0.5;
+                entityItem.pickupDelay = 0;
             }
         }
 
@@ -288,15 +287,15 @@ public class MinecartEntity extends Entity implements Container {
         int blockX = MathHelper.floor(x);
         int blockY = MathHelper.floor(y);
         int blockZ = MathHelper.floor(z);
-        if(RailBlock.isRailBlockAt(world, blockX, blockY - 1, blockZ)) {
+        if(BlockRail.isRailBlockAt(world, blockX, blockY - 1, blockZ)) {
             blockY--;
         }
         final double maxSpeed = 0.4D;
         boolean didFurnacePush = false;
         final double d5 = 0.0078125D;
         Block block = world.getBlock(blockX, blockY, blockZ);
-        if(block instanceof RailBlock) {
-            RailBlock rail = (RailBlock) block;
+        if(block instanceof BlockRail) {
+            BlockRail rail = (BlockRail) block;
             Vec3 vec3d = getPos(x, y, z);
             y = blockY;
             boolean onPoweredPoweredRail = false;
@@ -519,14 +518,14 @@ public class MinecartEntity extends Entity implements Container {
         int blockX = MathHelper.floor(x);
         int blockY = MathHelper.floor(y);
         int blockZ = MathHelper.floor(z);
-        if(RailBlock.isRailBlockAt(world, blockX, blockY - 1, blockZ)) {
+        if(BlockRail.isRailBlockAt(world, blockX, blockY - 1, blockZ)) {
             blockY--;
         }
 
         Block block = world.getBlock(blockX, blockY, blockZ);
-        if (!(block instanceof RailBlock)) { return null; }
+        if (!(block instanceof BlockRail)) { return null; }
 
-        RailBlock rail = (RailBlock) block;
+        BlockRail rail = (BlockRail) block;
         int meta = world.getBlockMetadata(blockX, blockY, blockZ);
         if(rail.getIsPowered()) {
             meta &= 0b111;
@@ -560,13 +559,13 @@ public class MinecartEntity extends Entity implements Container {
         int blockY = MathHelper.floor(y);
         int blockZ = MathHelper.floor(z);
 
-        if(RailBlock.isRailBlockAt(world, blockX, blockY - 1, blockZ)) {
+        if(BlockRail.isRailBlockAt(world, blockX, blockY - 1, blockZ)) {
             blockY--;
         }
         Block block = world.getBlock(blockX, blockY, blockZ);
-        if (!(block instanceof RailBlock)) { return null; }
+        if (!(block instanceof BlockRail)) { return null; }
 
-        RailBlock rail = (RailBlock) block;
+        BlockRail rail = (BlockRail) block;
         RailDirection direction = rail.getRailDirection(world, blockX, blockY, blockZ);
 
         int[][] offsetMap = EXITS[direction.meta];
@@ -705,8 +704,8 @@ public class MinecartEntity extends Entity implements Container {
             case PASSENGER_CART:
                 if (!world.isClientSide && passenger == null && player.isSneaking() && player.getHeldObject() instanceof CarriedBlock) {
                     CarriedBlock carriedBlock = (CarriedBlock) player.getHeldObject();
-                    if (carriedBlock.entity instanceof ChestBlockEntity) {
-                        ChestBlockEntity chest = (ChestBlockEntity) carriedBlock.entity;
+                    if (carriedBlock.entity instanceof TileEntityChest) {
+                        TileEntityChest chest = (TileEntityChest) carriedBlock.entity;
                         this.type = CHEST_CART;
                         if (carriedBlock.blockId == Blocks.CHEST_PLANKS_OAK_PAINTED.id) {
                             this.typeMeta = carriedBlock.metadata & TYPE_MASK_COLOR | TYPE_MASK_PAINTED_CHEST;
@@ -731,7 +730,7 @@ public class MinecartEntity extends Entity implements Container {
             case CHEST_CART:
                 if(!world.isClientSide) {
                     if (player.isSneaking() && player.inventory.getCurrentItem() == null && player.getHeldObject() == null) {
-                        ChestBlockEntity blockEntity = new ChestBlockEntity();
+                        TileEntityChest blockEntity = new TileEntityChest();
                         for (int i = 0; i < this.getContainerSize(); i++) {
                             blockEntity.setItem(i, this.getItem(i));
                             this.setItem(i, null);
@@ -816,7 +815,7 @@ public class MinecartEntity extends Entity implements Container {
                 break;
         }
     }
-    // Inventory Stuff
+    // ContainerInventory Stuff
 
 
     @Override
diff --git a/src/main/java/net/minecraft/core/enums/MobCategory.java b/src/main/java/net/minecraft/core/enums/MobCategory.java
index 4ac9289a7..dcaa347ee 100644
--- a/src/main/java/net/minecraft/core/enums/MobCategory.java
+++ b/src/main/java/net/minecraft/core/enums/MobCategory.java
@@ -1,16 +1,16 @@
 package net.minecraft.core.enums;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.animal.Animal;
-import net.minecraft.core.entity.animal.WaterAnimal;
+import net.minecraft.core.entity.animal.MobAnimal;
+import net.minecraft.core.entity.animal.MobWaterAnimal;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.monster.Enemy;
 
 public enum MobCategory {
 
 	monster("monster", 0, Enemy.class, 70, Material.air, false),
-    creature("creature", 1, Animal.class, 15, Material.air, true),
-    waterCreature("waterCreature", 2, WaterAnimal.class, 5, Material.water, true),
+    creature("creature", 1, MobAnimal.class, 15, Material.air, true),
+    waterCreature("waterCreature", 2, MobWaterAnimal.class, 5, Material.water, true),
     ambientCreature("ambient", 3, Entity.class, 2, Material.air, true);
 	
 	private final Class<?> baseClass;
diff --git a/src/main/java/net/minecraft/core/item/Item.java b/src/main/java/net/minecraft/core/item/Item.java
index 4dc0b3dd1..ad227b48c 100644
--- a/src/main/java/net/minecraft/core/item/Item.java
+++ b/src/main/java/net/minecraft/core/item/Item.java
@@ -5,7 +5,7 @@ import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.achievement.stat.StatItem;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.data.tag.ITaggable;
 import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.entity.Entity;
@@ -162,7 +162,7 @@ public class Item implements ITaggable<Item>, IItemConvertible
         return false;
     }
 
-    public void onUseByActivator(ItemStack itemStack, ActivatorBlockEntity activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
+    public void onUseByActivator(ItemStack itemStack, TileEntityActivator activatorBlock, World world, Random random, int blockX, int blockY, int blockZ, double offX, double offY, double offZ, Direction direction) {
     }
 
     public float getStrVsBlock(ItemStack itemstack, Block block)
